#include <iostream>
#include <vector>

using namespace std;


struct Input{
vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(){
    Input in;
    size_t number_count;
    cin >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cin >> in.bin_count;
    return in;
}

void
find_minmax(vector<double> numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}

vector<size_t>
make_histogram(vector<double> numbers, int bin_count){
    vector<size_t> bins(bin_count);
    double min = numbers[0];
    double max = numbers[0];
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    for (auto x: numbers) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= x) && (x < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

void
show_histogram_text(vector<size_t> bins){
    for(size_t count: bins){
        if (count < 100) cout << " ";
        if (count < 10) cout << " ";
        cout << count << "|";
    for(size_t i = 0; i < count; ++i) cout << "*";
        cout << "\n";
        }
}

int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);
}
